Overview | Package | Class | Tree | Deprecated | Index | Help
| © 2002 BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.p13n.ad
Interface AdBucketService

public interface AdBucketService
extends javax.ejb.EJBObject, ContentBucket

The remote bean interface for the AdBucketService. The AdBucketService implements the ContentBucket interface and provides ad content to the PlaceholderService. There are two "buckets" of ad that may be searched. Associated with each user is an AdBucket. If the ad isn't found in the users AdBucket then a global AdBucket is searched. When multiple ads are legal, the AdConflictResolver is called to select the "best" ad to be displayed.

The AdBucketService provides methods to add ads to user AdBuckets. In addition, there is a cleanup method which will remove all of the ads associated with a container.

Preview manages the life time of a query preview and allows all possible content matching the query to be rendered and returned to some type of preview object.

Inner classes inherited from class com.bea.p13n.placeholder.ContentBucket
`ContentBucket.PreviewInfo`

Method Summary
`void` | `cleanupAdBucket(java.lang.String containerUID)` Remove the information about a container from both the user and global ad buckets.
`AdInfo` | `getAdEventInfo(long adBucketId)` Get the AdInfo required to post an event for the specified bucket id.
`java.lang.String` | `getContent(java.lang.String placeholderName, boolean mixGlobals, java.lang.String userId, java.lang.String servletBase, Request request, int height, int width)` Return the content for the requested ad
`java.util.Collection` | `getGlobalQueries(java.lang.String placeholderName)` Get the list of AdInfos that represent the global queries for the specified placeholder.
`java.util.Collection` | `previewContent(java.lang.String servletBase, java.lang.String query, boolean renderContent)` Return a collection of PreviewInfo structures which match all of the content for the query.
`java.util.Collection` | `previewContent(java.lang.String userId, java.lang.String servletBase, java.lang.String query)` Deprecated. Use previewContent(String, String, boolean) instead.
`void` | `removeGlobalQueries(java.lang.String placeholderName, boolean removeAll)` Remove queries from the add bucket.
`void` | `setGlobalQuery(java.lang.String placeholderName, java.lang.String query, int weight)` Set a global query for the placeholder.
`boolean` | `userAddAd(AdInfo adInfo, boolean remove)` Add the adInfo to the user's AdBucket
`int` | `userClearAds(java.lang.String userId, java.lang.String placeholderName, java.lang.String containerUID, java.lang.String containerType)` Clear user ads in a bucket.

Methods inherited from interface javax.ejb.EJBObject
`getEJBHome, getHandle, getPrimaryKey, isIdentical, remove`

Method Detail

### getContent

    public java.lang.String getContent(java.lang.String placeholderName,
                                       boolean mixGlobals,
                                       java.lang.String userId,
                                       java.lang.String servletBase,
                                       Request request,
                                       int height,
                                       int width)
                                throws java.rmi.RemoteException,
                                       ContentException

  Return the content for the requested ad
  Specified by:
    getContent in interface ContentBucket

  Parameters:
    `placeholderName` - The name of the placeholder
    `mixGlobals` - Mix globals with bucket ads?
    `userId` - The user id
    `servletBase` - The Web App base for the click thru servlet
    `request` - The HTTP request
    `height` - The desired height
    `width` - The desired width
  Returns:
    the content of an ad for the placeholder as an XHTML string.

### previewContent

    public java.util.Collection previewContent(java.lang.String servletBase,
                                               java.lang.String query,
                                               boolean renderContent)
                                        throws java.rmi.RemoteException,
                                               ContentException

  Return a collection of PreviewInfo structures which match all of the content for the query.
  Specified by:
    previewContent in interface ContentBucket

  Parameters:
    `servletBase` - The Web App base for the click thru servlet
    `query` - The content query to be previewed
    `renderContent` - true to include the rendering content in the preview, false to not.
  Returns:
    the collection of PreviewInfo structures that would be matched by the content query.

### previewContent

    public java.util.Collection previewContent(java.lang.String userId,
                                               java.lang.String servletBase,
                                               java.lang.String query)
                                        throws java.rmi.RemoteException,
                                               ContentException

  Deprecated. Use previewContent(String, String, boolean) instead.
  Return a collection of PreviewInfo structures which match all of the content for the query (with rendered content).

  Parameters:
    `userId` - the user name.
    `servletBase` - The Web App base for the click thru servlet
    `query` - The content query to be previewed
  Returns:
    the collection of PreviewInfo structures that would be matched by the content query.

### setGlobalQuery

    public void setGlobalQuery(java.lang.String placeholderName,
                               java.lang.String query,
                               int weight)
                        throws java.rmi.RemoteException,
                               ContentException

  Set a global query for the placeholder. A placeholder may have more than one global query.
  Specified by:
    setGlobalQuery in interface ContentBucket

  Parameters:
    `placeholderName` - the name of the placeholder setting the global query
    `query` - The query expression of the query.
    `weight` - The weight associated with the query

### removeGlobalQueries

    public void removeGlobalQueries(java.lang.String placeholderName,
                                    boolean removeAll)
                             throws java.rmi.RemoteException,
                                    ContentException

  Remove queries from the add bucket. This will remove all or only global queries depending on the removeAll parameter.
  Specified by:
    removeGlobalQueries in interface ContentBucket

  Parameters:
    `placeholderName` - the name of the placeholder
    `removeAll` - if true remove all entries for the placeholder, otherwise simply remove the global entries.

### getGlobalQueries

    public java.util.Collection getGlobalQueries(java.lang.String placeholderName)
                                          throws java.rmi.RemoteException,
                                                 ContentException

  Get the list of AdInfos that represent the global queries for the specified placeholder.

### userAddAd

    public boolean userAddAd(AdInfo adInfo,
                             boolean remove)
                      throws java.rmi.RemoteException,
                             ContentException

  Add the adInfo to the user's AdBucket

  Parameters:
    `adInfo` - the ad related information
    `remove` - if the AdInfo already exists, true to remove it, false to update it.
  Returns:
    true if the Ad is added, false otherwise
  Throws:
    Content - when the content cannot be created

### userClearAds

    public int userClearAds(java.lang.String userId,
                            java.lang.String placeholderName,
                            java.lang.String containerUID,
                            java.lang.String containerType)
                     throws java.rmi.RemoteException,
                            ContentException

  Clear user ads in a bucket.

  Parameters:
    `userId` - the userId (null for current, only admin users can clear other user's buckets).
    `placeholderName` - the name of the placeholder to clear (null for all placeholders).
    `containerUID` - the uid of the container to clear (null for all containers).
    `containerType` - the type of the container to clear (null for all container types).
  Returns:
    the number of ad entries cleared.
  Throws:
    ContentException - thrown on an error.

### getAdEventInfo

    public AdInfo getAdEventInfo(long adBucketId)
                          throws java.rmi.RemoteException,
                                 ContentException

  Get the AdInfo required to post an event for the specified bucket id.

  The AdInfo returned will only have a bucketId, placeholderName, containerUID, and contextUID.

  Returns:
    the info on success, null on no such id.

### cleanupAdBucket

    public void cleanupAdBucket(java.lang.String containerUID)
                         throws java.rmi.RemoteException,
                                ContentException

  Remove the information about a container from both the user and global ad buckets.

  Parameters:
    `containerUID` - The name of the container that we are cleaning up

Overview | Package | Class | Tree | Deprecated | Index | Help
| © 2002 BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 BEA Systems, Inc. All Rights Reserved